Codeforces Round #398 (Div. 2) -- C. Garland (dfs)

40 篇文章 1 订阅

大体题意:

给你一颗树,要求切掉两个边,使得剩下的三个子树权值相同,问切哪两个边? 没有输出-1

思路:

因为第一次删除肯定是删除一个完整子树。

所以直接统计出每个点包含的完整子树的权值之和, 发现一个点的权值之和等于sum/3 的话,就把它切掉,直到切掉两个为止。

注意:

切掉之后点的权值之和会发生改变。

其次 根节点不能被切。

#include <bits/stdc++.h>
#define mr make_pair
#define ps push_back
#define fi first
#define se second
#define Siz(x) (int)x.size()
using namespace std;
typedef long long LL;
typedef unsigned long long ULL;
const double eps = 1e-10;
const int inf = 0x3f3f3f3f;
const double pi = acos(-1.0);


const int maxn = 1e6 + 10;
vector<int>g[maxn];
int sum = 0;
int dp[maxn],w[maxn], n;
int root, ans[2];
void dfs(int cur){
    dp[cur] = w[cur];
    for (int i = 0; i < Siz(g[cur]); ++i){
        int v = g[cur][i];
        dfs(v);
        dp[cur] += dp[v];

    }
    if (dp[cur] == sum && cur != root ){
        if (ans[0] == 0) ans[0] = cur,dp[cur] = 0;
        else if (ans[1] == 0)ans[1] = cur,dp[cur] = 0;
    }
}

int main(){

    scanf("%d",&n);
    for (int i = 1; i <= n; ++i){
        int u,v;
        scanf("%d %d",&u, &v);
        g[u].ps(i);
        w[i] = v;
        if (u == 0) root = i;
        sum += v;
    }
    if (sum % 3) return 0 * puts("-1");
    sum /= 3;
    dfs(root);
    if (ans[0] == 0 || ans[1] == 0) return 0 * puts("-1");
    printf("%d %d\n",ans[0], ans[1]);
    return 0;
}

/**
6
2 4
0 -1
4 2
2 3
1 2
4 5

**/

C. Garland
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Once at New Year Dima had a dream in which he was presented a fairy garland. A garland is a set of lamps, some pairs of which are connected by wires. Dima remembered that each two lamps in the garland were connected directly or indirectly via some wires. Furthermore, the number of wires was exactly one less than the number of lamps.

There was something unusual about the garland. Each lamp had its own brightness which depended on the temperature of the lamp. Temperatures could be positive, negative or zero. Dima has two friends, so he decided to share the garland with them. He wants to cut two different wires so that the garland breaks up into three parts. Each part of the garland should shine equally, i. e. the sums of lamps' temperatures should be equal in each of the parts. Of course, each of the parts should be non-empty, i. e. each part should contain at least one lamp.

Help Dima to find a suitable way to cut the garland, or determine that this is impossible.

While examining the garland, Dima lifted it up holding by one of the lamps. Thus, each of the lamps, except the one he is holding by, is now hanging on some wire. So, you should print two lamp ids as the answer which denote that Dima should cut the wires these lamps are hanging on. Of course, the lamp Dima is holding the garland by can't be included in the answer.

Input

The first line contains single integer n (3 ≤ n ≤ 106) — the number of lamps in the garland.

Then n lines follow. The i-th of them contain the information about the i-th lamp: the number lamp ai, it is hanging on (and 0, if is there is no such lamp), and its temperature ti ( - 100 ≤ ti ≤ 100). The lamps are numbered from 1 to n.

Output

If there is no solution, print -1.

Otherwise print two integers — the indexes of the lamps which mean Dima should cut the wires they are hanging on. If there are multiple answers, print any of them.

Examples
input
6
2 4
0 5
4 2
2 1
1 1
4 2
output
1 4
input
6
2 4
0 6
4 2
2 1
1 1
4 2
output
-1
Note

The garland and cuts scheme for the first example:



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值